//
//  ProfilePresenter.swift
//  VKExt
//
//  Created programmist_NA on 25.05.2020.
//  Copyright © 2020 ___ORGANIZATIONNAME___. All rights reserved.
//
//  Template generated by Juanpe Catalán @JuanpeCMiOS
//

import UIKit

class ProfilePresenter: ProfilePresenterProtocol {
    weak private var view: ProfileViewProtocol?
    var interactor: ProfileInteractorProtocol?
    private let router: ProfileWireframeProtocol
    let selfService = SelfService.instance
    
    init(interface: ProfileViewProtocol, interactor: ProfileInteractorProtocol?, router: ProfileWireframeProtocol) {
        self.view = interface
        self.interactor = interactor
        self.router = router
    }
    
    func start(request: ProfileModel.Request.RequestType) {
        guard let interactor = interactor else { return }
        interactor.start(request: request)
    }
    
    func presentData(response: ProfileModel.Response.ResponseType) {
        switch response {
        case .presentProfileFirstInfo(profile: let profile):
            let cell = profileCellViewModel(from: profile)
            
            let profileViewModel = ProfileViewModel.init(cell: cell, footerTitle: "")
            DispatchQueue.main.async {
                self.view?.displayData(viewModel: .displayProfileFirstInfo(profileViewModel: profileViewModel))
            }
        case .presentProfileSecondInfo(profile: let profile):
            let cell = profileCellViewModel(from: profile)
            
            let profileViewModel = ProfileViewModel.init(cell: cell, footerTitle: "")
            DispatchQueue.main.async {
                self.view?.displayData(viewModel: .displayProfileSecondInfo(profileViewModel: profileViewModel))
            }
        case .presentProfilePhotos(profile: let profile):
            let cells = profile.items?.compactMap { (item) in
                photoCellViewModel(from: profile)
            }
            
            let photoViewModel = PhotoViewModel.init(cell: cells ?? [], footerTitle: "")
            DispatchQueue.main.async {
                self.view?.displayData(viewModel: .displayProfilePhotos(profileViewModel: photoViewModel))
            }
        case .presentProfileWall(wall: let wall, revealdedPostIds: let revealdedPostIds):
            let cells = wall.items.map { (wallItem) in
                cellViewModel(from: wallItem, profiles: wall.profiles, groups: wall.groups, revealdedPostIds: revealdedPostIds)
            }
            
            let footerTitle = String.localizedStringWithFormat(NSLocalizedString("newsfeed cells count", comment: ""), cells.count)
            let wallViewModel = FeedViewModel.init(cells: cells, footerTitle: footerTitle)
            DispatchQueue.main.async {
                self.view?.displayData(viewModel: .displayWall(wallViewModel: wallViewModel))
            }
        case .presentFooterLoader:
            DispatchQueue.main.async {
                self.view?.displayData(viewModel: .displayFooterLoader)
            }
        case .presentFooterError(message: let message):
            DispatchQueue.main.async {
                self.view?.displayData(viewModel: .displayFooterError(message: message))
            }
        }
    }

    func onLikePost(request: ProfileModel.Request.RequestType) {
        guard let interactor = self.interactor else { return }
        interactor.makeRequest(request: request)
    }
    
    private func profileCellViewModel(from profile: ProfileResponse) -> ProfileViewModel.Cell {
        var action: FriendAction
        switch profile.friendStatus {
        case 0:
            action = profile.canSendFriendRequest == 1 ? .notFriend : .notFriendWithNoRequest
        case 1:
            action = .requestSend
        case 2:
            action = .incomingRequest
        case 3:
            action = .isFriend
        default:
            action = .notFriend
        }
        var canWriteMessageAction: ProfileActionType
        if profile.canWritePrivateMessage == 0 {
            canWriteMessageAction = .actionFriend
        } else {
            canWriteMessageAction = .actionFriendWithMessage
        }
        let profileCellViewModel = ProfileViewModel.Cell.init(isCurrentProfile: profile.id == VKConstants.currentUserId, friendActionType: action, type: canWriteMessageAction, id: profile.id, firstName: profile.firstName, lastName: profile.lastName, isClosed: profile.isClosed, canAccessClosed: profile.canAccessClosed, canPost: profile.canPost?.boolValue, blacklisted: profile.blacklisted?.boolValue, sex: profile.sex, screenName: profile.screenName, bdate: profile.bdate, isOnline: profile.onlineInfo?.isOnline, isMobile: profile.onlineInfo?.isMobile, photo100: profile.photo100, photoMaxOrig: profile.photoMaxOrig, status: profile.status, friendsCount: profile.counters?.friends, followersCount: profile.followersCount, school: profile.schools?.isEmpty ?? true ? nil : profile.schools?[0].name, work: profile.career?.isEmpty ?? true ? nil : profile.occupation?.name)
        return profileCellViewModel
    }
    
    private func photoCellViewModel(from photo: PhotoResponse) -> PhotoViewModel.Cell {
        let photoViewModel = PhotoViewModel.Cell.init(photos: photos(photoItem: photo))
        return photoViewModel
    }
    
    private func photos(photoItem: PhotoResponse) -> [PhotoViewModel.ProfilePhotosCellViewModel] {
        return photoItem.items!.compactMap({ (photo) -> PhotoViewModel.ProfilePhotosCellViewModel? in
            return PhotoViewModel.ProfilePhotosCellViewModel.init(photoMaxUrl: photo.srcMax,
                                                                  photoUrlString: photo.srcBIG,
                                                              width: photo.width,
                                                              height: photo.height)
        })
    }
    
    private func cellViewModel(from wallItem: WallItem, profiles: [Profile], groups: [Group], revealdedPostIds: [Int]) -> FeedViewModel.Cell {
        let profile = self.profile(for: wallItem.ownerId, profiles: profiles, groups: groups)
        
        let photoAttachments = self.photoAttachments(wallItem: wallItem)
        
        let date = Date(timeIntervalSince1970: wallItem.date)
        let dateTitle = selfService.postDate(with: date).string(from: date)
        
        let isFullSized = revealdedPostIds.contains { (postId) -> Bool in
            return postId == wallItem.id
        }

        let sizes = selfService.cellLayoutCalculator.sizes(postText: wallItem.text, photoAttachments: photoAttachments, isFullSizedPost: isFullSized, isRepost: false)
        
        let postText = wallItem.text?.replacingOccurrences(of: "<br>", with: "\n")
        
        if let repost = wallItem.copyHistory?.first {
            let profileRepost = self.profile(for: repost.ownerId, profiles: profiles, groups: groups)
            let photoRepostAttachments = self.photoAttachments(repostItem: repost)
            let repostText = repost.text?.replacingOccurrences(of: "<br>", with: "\n")
            let date = Date(timeIntervalSince1970: repost.date)
            let dateTitle = selfService.postDate(with: date).string(from: date)
            
            let feedRepostCellViewModel = FeedViewModel.FeedRepost.init(id: repost.id, ownerId: repost.ownerId, type: repost.postType, iconUrlString: profileRepost.photo, name: profileRepost.name, date: dateTitle, text: repostText, photoAttachements: photoRepostAttachments)
            
            let isFullSized = revealdedPostIds.contains { (postId) -> Bool in
                return postId == repost.id
            }
            
            let sizes = selfService.cellLayoutCalculator.sizes(postText: repost.text, photoAttachments: photoRepostAttachments, isFullSizedPost: isFullSized, isRepost: true)
            
            return FeedViewModel.Cell.init(postId: wallItem.id,
                                           sourceId: repost.ownerId,
                                           type: repost.postType,
                                           iconUrlString: profile.photo,
                                           name: profile.name,
                                           date: dateTitle,
                                           text: postText,
                                           likes: formattedCounter(wallItem.likes?.count),
                                           userLikes: wallItem.likes?.userLikes,
                                           comments: formattedCounter(wallItem.comments?.count),
                                           shares: formattedCounter(wallItem.reposts?.count),
                                           views: formattedCounter(wallItem.views?.count),
                                           photoAttachements: photoAttachments,
                                           repost: [feedRepostCellViewModel],
                                           sizes: sizes)
        } else {
            return FeedViewModel.Cell.init(postId: wallItem.id,
                                           sourceId: wallItem.ownerId,
                                           type: wallItem.postType,
                                           iconUrlString: profile.photo,
                                           name: profile.name,
                                           date: dateTitle,
                                           text: postText,
                                           likes: formattedCounter(wallItem.likes?.count),
                                           userLikes: wallItem.likes?.userLikes,
                                           comments: formattedCounter(wallItem.comments?.count),
                                           shares: formattedCounter(wallItem.reposts?.count),
                                           views: formattedCounter(wallItem.views?.count),
                                           photoAttachements: photoAttachments,
                                           repost: nil,
                                           sizes: sizes)
        }
    }
    
    private func formattedCounter(_ counter: Int?) -> String? {
        guard let counter = counter, counter > 0 else { return nil }
        var counterString = String(counter)
        if 4...6 ~= counterString.count {
            counterString = String(counterString.dropLast(3)) + "K"
        } else if counterString.count > 6 {
            counterString = String(counterString.dropLast(6)) + "M"
        }
        return counterString
    }
    
    private func profile(for sourseId: Int, profiles: [Profile], groups: [Group]) -> ProfileRepresenatable {
        
        let profilesOrGroups: [ProfileRepresenatable] = sourseId >= 0 ? profiles : groups
        let normalSourseId = sourseId >= 0 ? sourseId : -sourseId
        let profileRepresenatable = profilesOrGroups.first { (myProfileRepresenatable) -> Bool in
            myProfileRepresenatable.id == normalSourseId
        }
        return profileRepresenatable!
    }
        
    private func photoAttachments(wallItem: WallItem) -> [FeedViewModel.FeedCellPhotoAttachment] {
        guard let attachments = wallItem.attachments else { return [] }
        
        return attachments.compactMap({ (attachment) -> FeedViewModel.FeedCellPhotoAttachment? in
            if let photo = attachment.photo {
                return FeedViewModel.FeedCellPhotoAttachment.init(photoUrlString: photo.srcBIG,
                                                                  photoMaxUrl: photo.srcMax,
                                                                  width: photo.width,
                                                                  height: photo.height)
            } else if let doc = attachment.doc {
                return FeedViewModel.FeedCellPhotoAttachment.init(gifUrl: doc.url,
                                                                  photoUrlString: doc.preview?.photo?.srcBIG ?? "",
                                                                  photoMaxUrl: doc.preview?.photo?.srcMax ?? "",
                                                                  width: doc.preview?.photo?.width ?? 0,
                                                                  height: doc.preview?.photo?.height ?? 0)
            } else {
                return nil
            }
        })
    }
    
    private func photoAttachments(repostItem: RepostItem) -> [FeedViewModel.FeedCellPhotoAttachment] {
        guard let attachments = repostItem.attachments else { return [] }
        
        return attachments.compactMap({ (attachment) -> FeedViewModel.FeedCellPhotoAttachment? in
            if let photo = attachment.photo {
                return FeedViewModel.FeedCellPhotoAttachment.init(photoUrlString: photo.srcBIG,
                                                                  photoMaxUrl: photo.srcMax,
                                                                  width: photo.width,
                                                                  height: photo.height)
            } else if let doc = attachment.doc {
                return FeedViewModel.FeedCellPhotoAttachment.init(gifUrl: doc.url,
                                                                  photoUrlString: doc.preview?.photo?.srcBIG ?? "",
                                                                  photoMaxUrl: doc.preview?.photo?.srcMax ?? "",
                                                                  width: doc.preview?.photo?.width ?? 0,
                                                                  height: doc.preview?.photo?.height ?? 0)
            } else {
                return nil
            }
        })
    }
}
